Code

Merge branch 'sn/doc-update-index-assume-unchanged' into maint-1.7.3
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example:       git-rebase master~1 topic
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 strategy_opts=
48 do_merge=
49 dotest="$GIT_DIR"/rebase-merge
50 prec=4
51 verbose=
52 diffstat=
53 test "$(git config --bool rebase.stat)" = true && diffstat=t
54 git_am_opt=
55 rebase_root=
56 force_rebase=
57 allow_rerere_autoupdate=
59 continue_merge () {
60         test -n "$prev_head" || die "prev_head must be defined"
61         test -d "$dotest" || die "$dotest directory does not exist"
63         unmerged=$(git ls-files -u)
64         if test -n "$unmerged"
65         then
66                 echo "You still have unmerged paths in your index"
67                 echo "did you forget to use git add?"
68                 die "$RESOLVEMSG"
69         fi
71         cmt=`cat "$dotest/current"`
72         if ! git diff-index --quiet --ignore-submodules HEAD --
73         then
74                 if ! git commit --no-verify -C "$cmt"
75                 then
76                         echo "Commit failed, please do not call \"git commit\""
77                         echo "directly, but instead do one of the following: "
78                         die "$RESOLVEMSG"
79                 fi
80                 if test -z "$GIT_QUIET"
81                 then
82                         printf "Committed: %0${prec}d " $msgnum
83                 fi
84                 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
85         else
86                 if test -z "$GIT_QUIET"
87                 then
88                         printf "Already applied: %0${prec}d " $msgnum
89                 fi
90         fi
91         test -z "$GIT_QUIET" &&
92         GIT_PAGER='' git log --format=%s -1 "$cmt"
94         prev_head=`git rev-parse HEAD^0`
95         # save the resulting commit so we can read-tree on it later
96         echo "$prev_head" > "$dotest/prev_head"
98         # onto the next patch:
99         msgnum=$(($msgnum + 1))
100         echo "$msgnum" >"$dotest/msgnum"
103 call_merge () {
104         cmt="$(cat "$dotest/cmt.$1")"
105         echo "$cmt" > "$dotest/current"
106         hd=$(git rev-parse --verify HEAD)
107         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
108         msgnum=$(cat "$dotest/msgnum")
109         end=$(cat "$dotest/end")
110         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
111         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
112         export GITHEAD_$cmt GITHEAD_$hd
113         if test -n "$GIT_QUIET"
114         then
115                 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
116         fi
117         eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
118         rv=$?
119         case "$rv" in
120         0)
121                 unset GITHEAD_$cmt GITHEAD_$hd
122                 return
123                 ;;
124         1)
125                 git rerere $allow_rerere_autoupdate
126                 die "$RESOLVEMSG"
127                 ;;
128         2)
129                 echo "Strategy: $rv $strategy failed, try another" 1>&2
130                 die "$RESOLVEMSG"
131                 ;;
132         *)
133                 die "Unknown exit code ($rv) from command:" \
134                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
135                 ;;
136         esac
139 move_to_original_branch () {
140         test -z "$head_name" &&
141                 head_name="$(cat "$dotest"/head-name)" &&
142                 onto="$(cat "$dotest"/onto)" &&
143                 orig_head="$(cat "$dotest"/orig-head)"
144         case "$head_name" in
145         refs/*)
146                 message="rebase finished: $head_name onto $onto"
147                 git update-ref -m "$message" \
148                         $head_name $(git rev-parse HEAD) $orig_head &&
149                 git symbolic-ref HEAD $head_name ||
150                 die "Could not move back to $head_name"
151                 ;;
152         esac
155 finish_rb_merge () {
156         move_to_original_branch
157         git notes copy --for-rewrite=rebase < "$dotest"/rewritten
158         if test -x "$GIT_DIR"/hooks/post-rewrite &&
159                 test -s "$dotest"/rewritten; then
160                 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
161         fi
162         rm -r "$dotest"
163         say All done.
166 is_interactive () {
167         while test $# != 0
168         do
169                 case "$1" in
170                         -i|--interactive)
171                                 interactive_rebase=explicit
172                                 break
173                         ;;
174                         -p|--preserve-merges)
175                                 interactive_rebase=implied
176                         ;;
177                 esac
178                 shift
179         done
181         if [ "$interactive_rebase" = implied ]; then
182                 GIT_EDITOR=:
183                 export GIT_EDITOR
184         fi
186         test -n "$interactive_rebase" || test -f "$dotest"/interactive
189 run_pre_rebase_hook () {
190         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
191            test -x "$GIT_DIR/hooks/pre-rebase"
192         then
193                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
194                 die "The pre-rebase hook refused to rebase."
195         fi
198 test -f "$GIT_DIR"/rebase-apply/applying &&
199         die 'It looks like git-am is in progress. Cannot rebase.'
201 is_interactive "$@" && exec git-rebase--interactive "$@"
203 while test $# != 0
204 do
205         case "$1" in
206         --no-verify)
207                 OK_TO_SKIP_PRE_REBASE=yes
208                 ;;
209         --continue)
210                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
211                         die "No rebase in progress?"
213                 git update-index --ignore-submodules --refresh &&
214                 git diff-files --quiet --ignore-submodules || {
215                         echo "You must edit all merge conflicts and then"
216                         echo "mark them as resolved using git add"
217                         exit 1
218                 }
219                 if test -d "$dotest"
220                 then
221                         prev_head=$(cat "$dotest/prev_head")
222                         end=$(cat "$dotest/end")
223                         msgnum=$(cat "$dotest/msgnum")
224                         onto=$(cat "$dotest/onto")
225                         GIT_QUIET=$(cat "$dotest/quiet")
226                         continue_merge
227                         while test "$msgnum" -le "$end"
228                         do
229                                 call_merge "$msgnum"
230                                 continue_merge
231                         done
232                         finish_rb_merge
233                         exit
234                 fi
235                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
236                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
237                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
238                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
239                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
240                 move_to_original_branch
241                 exit
242                 ;;
243         --skip)
244                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
245                         die "No rebase in progress?"
247                 git reset --hard HEAD || exit $?
248                 if test -d "$dotest"
249                 then
250                         git rerere clear
251                         prev_head=$(cat "$dotest/prev_head")
252                         end=$(cat "$dotest/end")
253                         msgnum=$(cat "$dotest/msgnum")
254                         msgnum=$(($msgnum + 1))
255                         onto=$(cat "$dotest/onto")
256                         GIT_QUIET=$(cat "$dotest/quiet")
257                         while test "$msgnum" -le "$end"
258                         do
259                                 call_merge "$msgnum"
260                                 continue_merge
261                         done
262                         finish_rb_merge
263                         exit
264                 fi
265                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
266                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
267                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
268                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
269                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
270                 move_to_original_branch
271                 exit
272                 ;;
273         --abort)
274                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
275                         die "No rebase in progress?"
277                 git rerere clear
279                 test -d "$dotest" || dotest="$GIT_DIR"/rebase-apply
281                 head_name="$(cat "$dotest"/head-name)" &&
282                 case "$head_name" in
283                 refs/*)
284                         git symbolic-ref HEAD $head_name ||
285                         die "Could not move back to $head_name"
286                         ;;
287                 esac
288                 git reset --hard $(cat "$dotest/orig-head")
289                 rm -r "$dotest"
290                 exit
291                 ;;
292         --onto)
293                 test 2 -le "$#" || usage
294                 newbase="$2"
295                 shift
296                 ;;
297         -M|-m|--m|--me|--mer|--merg|--merge)
298                 do_merge=t
299                 ;;
300         -X*|--strategy-option*)
301                 case "$#,$1" in
302                 1,-X|1,--strategy-option)
303                         usage ;;
304                 *,-X|*,--strategy-option)
305                         newopt="$2"
306                         shift ;;
307                 *,--strategy-option=*)
308                         newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
309                 *,-X*)
310                         newopt="$(expr " $1" : ' -X\(.*\)')" ;;
311                 1,*)
312                         usage ;;
313                 esac
314                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
315                 do_merge=t
316                 ;;
317         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
318                 --strateg=*|--strategy=*|\
319         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
320                 case "$#,$1" in
321                 *,*=*)
322                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
323                 1,*)
324                         usage ;;
325                 *)
326                         strategy="$2"
327                         shift ;;
328                 esac
329                 do_merge=t
330                 ;;
331         -n|--no-stat)
332                 diffstat=
333                 ;;
334         --stat)
335                 diffstat=t
336                 ;;
337         -v|--verbose)
338                 verbose=t
339                 diffstat=t
340                 GIT_QUIET=
341                 ;;
342         -q|--quiet)
343                 GIT_QUIET=t
344                 git_am_opt="$git_am_opt -q"
345                 verbose=
346                 diffstat=
347                 ;;
348         --whitespace=*)
349                 git_am_opt="$git_am_opt $1"
350                 case "$1" in
351                 --whitespace=fix|--whitespace=strip)
352                         force_rebase=t
353                         ;;
354                 esac
355                 ;;
356         --ignore-whitespace)
357                 git_am_opt="$git_am_opt $1"
358                 ;;
359         --committer-date-is-author-date|--ignore-date)
360                 git_am_opt="$git_am_opt $1"
361                 force_rebase=t
362                 ;;
363         -C*)
364                 git_am_opt="$git_am_opt $1"
365                 ;;
366         --root)
367                 rebase_root=t
368                 ;;
369         -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
370                 force_rebase=t
371                 ;;
372         --rerere-autoupdate|--no-rerere-autoupdate)
373                 allow_rerere_autoupdate="$1"
374                 ;;
375         -*)
376                 usage
377                 ;;
378         *)
379                 break
380                 ;;
381         esac
382         shift
383 done
384 test $# -gt 2 && usage
386 if test $# -eq 0 && test -z "$rebase_root"
387 then
388         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
389         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
390                 die 'A rebase is in progress, try --continue, --skip or --abort.'
391 fi
393 # Make sure we do not have $GIT_DIR/rebase-apply
394 if test -z "$do_merge"
395 then
396         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
397         then
398                 rmdir "$GIT_DIR"/rebase-apply
399         else
400                 echo >&2 '
401 It seems that I cannot create a rebase-apply directory, and
402 I wonder if you are in the middle of patch application or another
403 rebase.  If that is not the case, please
404         rm -fr '"$GIT_DIR"'/rebase-apply
405 and run me again.  I am stopping in case you still have something
406 valuable there.'
407                 exit 1
408         fi
409 else
410         if test -d "$dotest"
411         then
412                 die "previous rebase directory $dotest still exists." \
413                         'Try git rebase (--continue | --abort | --skip)'
414         fi
415 fi
417 # The tree must be really really clean.
418 if ! git update-index --ignore-submodules --refresh > /dev/null; then
419         echo >&2 "cannot rebase: you have unstaged changes"
420         git diff-files --name-status -r --ignore-submodules -- >&2
421         exit 1
422 fi
423 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
424 case "$diff" in
425 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
426         echo >&2 "$diff"
427         exit 1
428         ;;
429 esac
431 if test -z "$rebase_root"
432 then
433         # The upstream head must be given.  Make sure it is valid.
434         upstream_name="$1"
435         shift
436         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
437         die "invalid upstream $upstream_name"
438         unset root_flag
439         upstream_arg="$upstream_name"
440 else
441         test -z "$newbase" && die "--root must be used with --onto"
442         unset upstream_name
443         unset upstream
444         root_flag="--root"
445         upstream_arg="$root_flag"
446 fi
448 # Make sure the branch to rebase onto is valid.
449 onto_name=${newbase-"$upstream_name"}
450 case "$onto_name" in
451 *...*)
452         if      left=${onto_name%...*} right=${onto_name#*...} &&
453                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
454         then
455                 case "$onto" in
456                 ?*"$LF"?*)
457                         die "$onto_name: there are more than one merge bases"
458                         ;;
459                 '')
460                         die "$onto_name: there is no merge base"
461                         ;;
462                 esac
463         else
464                 die "$onto_name: there is no merge base"
465         fi
466         ;;
467 *)
468         onto=$(git rev-parse --verify "${onto_name}^0") || exit
469         ;;
470 esac
472 # If a hook exists, give it a chance to interrupt
473 run_pre_rebase_hook "$upstream_arg" "$@"
475 # If the branch to rebase is given, that is the branch we will rebase
476 # $branch_name -- branch being rebased, or HEAD (already detached)
477 # $orig_head -- commit object name of tip of the branch before rebasing
478 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
479 switch_to=
480 case "$#" in
481 1)
482         # Is it "rebase other $branchname" or "rebase other $commit"?
483         branch_name="$1"
484         switch_to="$1"
486         if git show-ref --verify --quiet -- "refs/heads/$1" &&
487            branch=$(git rev-parse -q --verify "refs/heads/$1")
488         then
489                 head_name="refs/heads/$1"
490         elif branch=$(git rev-parse -q --verify "$1")
491         then
492                 head_name="detached HEAD"
493         else
494                 echo >&2 "fatal: no such branch: $1"
495                 usage
496         fi
497         ;;
498 *)
499         # Do not need to switch branches, we are already on it.
500         if branch_name=`git symbolic-ref -q HEAD`
501         then
502                 head_name=$branch_name
503                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
504         else
505                 head_name="detached HEAD"
506                 branch_name=HEAD ;# detached
507         fi
508         branch=$(git rev-parse --verify "${branch_name}^0") || exit
509         ;;
510 esac
511 orig_head=$branch
513 # Now we are rebasing commits $upstream..$branch (or with --root,
514 # everything leading up to $branch) on top of $onto
516 # Check if we are already based on $onto with linear history,
517 # but this should be done only when upstream and onto are the same.
518 mb=$(git merge-base "$onto" "$branch")
519 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
520         # linear history?
521         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
522 then
523         if test -z "$force_rebase"
524         then
525                 # Lazily switch to the target branch if needed...
526                 test -z "$switch_to" || git checkout "$switch_to" --
527                 say "Current branch $branch_name is up to date."
528                 exit 0
529         else
530                 say "Current branch $branch_name is up to date, rebase forced."
531         fi
532 fi
534 # Detach HEAD and reset the tree
535 say "First, rewinding head to replay your work on top of it..."
536 git checkout -q "$onto^0" || die "could not detach HEAD"
537 git update-ref ORIG_HEAD $branch
539 if test -n "$diffstat"
540 then
541         if test -n "$verbose"
542         then
543                 echo "Changes from $mb to $onto:"
544         fi
545         # We want color (if set), but no pager
546         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
547 fi
549 # If the $onto is a proper descendant of the tip of the branch, then
550 # we just fast-forwarded.
551 if test "$mb" = "$branch"
552 then
553         say "Fast-forwarded $branch_name to $onto_name."
554         move_to_original_branch
555         exit 0
556 fi
558 if test -n "$rebase_root"
559 then
560         revisions="$onto..$orig_head"
561 else
562         revisions="$upstream..$orig_head"
563 fi
565 if test -z "$do_merge"
566 then
567         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
568                 --src-prefix=a/ --dst-prefix=b/ \
569                 --no-renames $root_flag "$revisions" |
570         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
571         move_to_original_branch
572         ret=$?
573         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
574                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
575                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
576                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
577                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
578         exit $ret
579 fi
581 # start doing a rebase with git-merge
582 # this is rename-aware if the recursive (default) strategy is used
584 mkdir -p "$dotest"
585 echo "$onto" > "$dotest/onto"
586 echo "$onto_name" > "$dotest/onto_name"
587 prev_head=$orig_head
588 echo "$prev_head" > "$dotest/prev_head"
589 echo "$orig_head" > "$dotest/orig-head"
590 echo "$head_name" > "$dotest/head-name"
591 echo "$GIT_QUIET" > "$dotest/quiet"
593 msgnum=0
594 for cmt in `git rev-list --reverse --no-merges "$revisions"`
595 do
596         msgnum=$(($msgnum + 1))
597         echo "$cmt" > "$dotest/cmt.$msgnum"
598 done
600 echo 1 >"$dotest/msgnum"
601 echo $msgnum >"$dotest/end"
603 end=$msgnum
604 msgnum=1
606 while test "$msgnum" -le "$end"
607 do
608         call_merge "$msgnum"
609         continue_merge
610 done
612 finish_rb_merge